function [g0,g1,Psi,Pie,CC,ss,exitflag] = modelnogrowth(param,nvar,nforerrors,ma1,ma2,ma3,ma4,ma5,ma6,ma7,ma8,cor)
%----------------------------------
% Set Parameters
%----------------------------------
   pnames = {
            'alph  '   	% 
            'bet   '    % 
            'gamm  '  	% 1
            'kappa  '   % 2
            'omegaw'    % 3    
            'omegap'    % 4
            'etaw'      % 
            'etap'      % 
            'mu'        %  
            'phipi'     % 5
            'phiy'      % 6
            'sg'        %
            'sb'        %
            'taul'		%
            'tauk'      %
            'tauc'      %
            'theta'     % 7
            'gpsi'      % 8
            's'         % 9 
            'chiw'      %10
            'chip'      %11
            'delt'      %
            'rhoa'		%12
            'rhob'      %13
            'rhor'      %14
            'rhoi'      %15
            'rhow'      %16
            'rhop'      %17
            'rhog'		%18
            'rhotk'     %19
            'rhotl'     %20
            'rhoz'      %21
            'gammg'	    %22
            'gammtk'	%
            'gammtl'    %
            'gammz'     %23
            'psitk'     %
            'psitl'     %
            'psigc'     %
            'psiz'      %
            'siga'      %24    
            'sigb'      %25
            'sigm'      %26
            'sigi'      %27
            'sigw'      %28
            'sigp'      %29
            'sigg'      %30
            'sigtk'     %31
            'sigtl'     %32
            'sigz'      %33
            'phipid'    %34
            'phiyd'     %35
            'phia'      %36
            'cor'
            
            'ma1'       %
            'ma2'       %
            'ma3'       %
            'ma4'       %
            'ma5'       %
            'ma6'       %
            'ma7'       %
            'ma8'       %


            };     

parameter = [ 0.36  % 1. alph: capital share
            0.99                % 2. bet: time preference
            param(1,1)       	% 3. gamm: curvature over consumption
            param(1,2)          % 4. kappa: curvature over leisure
            param(1,3)%0.1          % 5. omegaw: prob that union cannot reset optimal wage .7
            param(1,4)%0.1          % 6. omegap: prob that intermediat firms cannot reset optimal price .66 
            8                   % 7. etaw: elasticity of substitution b/w labor talents
            8                   % 8. etap: elasticity of substitution b/w intermediate goods
            0                   % 9. mu: share of Ricardian agents
            param(1,5)          % 10. phipi: Taylor rule inflation coefficient
            param(1,6)          % 11. phiY: Taylor rule output coefficient
            0.1708%.0698+.00395 % 12. sg:  
            .39543*4            % 13. sb 
            0.236               % 14. taul 
            0.359               % 15. tauk 
            0%.0149             % 16. tauc 
           param(1,7)  % 0        % 17. theta: habit formation parameter
           param(1,8) %0.99           % 18. gpsi: K utilization cost parameter; 1: no K utilization
           param(1,9) %0.01           % 19. s: s" in the investment adjustment cost function
           param(1,10)          % 20. chiw
           param(1,11)          % 21. chip: the percent of intermediate firms' price adjustment when they cannot optimize 
           0.025                % 22. delt: k depreciation
           param(1,12)          % 23. rhoa: serial correlation on A 
           param(1,13)          % 24. rhob: serial correlation on cons. preference (ub)
           param(1,14)          % 25. rhor: serial correlation on interest rate in Taylor rule
           param(1,15)          % 26. rhoi: serial correlation on ui
           param(1,16)          % 27. rhow: serial correlation on uw
           param(1,17)          % 28. rhop: serial correlation on up
           param(1,18)          % 29. rhog: serial correlation on GC
           param(1,19)          % 30. rhotk: serial correlation on tauk
           param(1,20)          % 31. rhotl: serial correlation on taul
           param(1,21)          % 32. rhoz: serial correlation on transfers
           param(1,22)          % 33. gammg: response of G to debt; 
           0%param(1,23)        % 34. gammtk: response of capital tax revenue to debt; 
           0%param(1,24)        % 35. gammtl: response of labor tax revenue to debt
           param(1,23)          % 36. gammz: response of transfers to debt
           0%param(1,26)        % 37. psitk
           0%param(1,27)        % 38. psitl
           0                    % 39. psigc: GC response to output, BP value
           0                    % 40. psiz: tr response to output
           param(1,24)          % 41. sigma
           param(1,25)          % 42. c sigma (ub)
           param(1,26)          % 43. m sigma
           param(1,27)          % 44. i sigma
           param(1,28)          % 45. w sigma
           param(1,29)          % 46. p sigma
           param(1,30)          % 47. g sigma
           param(1,31)          % 48. tk sigma
           param(1,32)          % 49. tl sigma
           param(1,33)          % 50. z sigma
           
           0%param(1,34)          % 51. phipid
           param(1,34)          % 52. phiyd
           0%param(1,36)          % 53. phia
           
           cor
       
           ma1                  %    ma1
           ma2                  %    ma2
           ma3                  %    ma3
           ma4                  %    ma4
           ma5                  %    ma5
           ma6                  %    ma6
           ma7                  %    ma7
           ma8                  %    ma8
                   ];
            
for j = 1:length(parameter)
    eval([char(pnames(j,:)) '=parameter(j);']);
end

%Solve for the steady state
R = 1/bet;
rk = (1 - bet*(1 - delt))/(bet*(1 - tauk)*(1+tauc));
%psi1 = rk*(1-tauk)*(1+tauc);
psi1 = rk*(1-tauk);

X(1) = 1;  %w
X(2) = 5;  %k/y
X(3) = 1;  %l/y
X(4) = .7; %c/y
X(5) = 1;  %y 
X(6) = 0.4;
X(7) = 0.7;
X(8) = 0.7;

%Solve w, k/y, l/y, c/y, y jointly
options = optimset('Display','off','MaxIter',10000,'TolFun',1e-10);
[X,fval,exitflag] = fsolve(@ssNLEst,X,options,parameter,rk,R);
w = X(1);
ky = X(2);
ly = X(3);
cy = X(4);
y = X(5);
str = X(6);
cry = X(7);
cnry = X(8);

cr = cry*y;
cnr = cnry*y;
k = ky*y;
iv = delt*k;
l = ly*y;
c = cy*y;
z = str*y;
b = sb*y;
g = sg*y;
lambr = ((1-theta)^(-gamm))*(cr^(-gamm));
lambnr = (cnr^(-gamm));
tk = rk*k*tauk;
tl = w*l*taul;
rev = tk + tl;
ss = [c iv y l tk tl g rev k];

% Load variables
variables

g0 = zeros(nvar,nvar);
g1 = g0;
CC = zeros(nvar,1);
Psi = zeros(nvar,nvar);
Pie = zeros(nvar,nforerrors);
%-------------------------------------------------------------------------------
%   (1)
%   real interest rate (FOC B)
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ncr) = 1;
eq1(Ncr) = theta/(1+theta);
eq0(Nxcr) = -1/(1+theta);
eq0(NR) = (1-theta)/(gamm*(1+theta));
eq0(Nxpi) = -(1-theta)/(gamm*(1+theta));
eq0(Nub) = -(1-theta)/(gamm*(1+theta));
eq0(Nxub) = (1-theta)/(gamm*(1+theta));
g0(1,:) = eq0;
g1(1,:) = eq1;
Psi(1,:) = eq0ex;
%-------------------------------------------------------------------------------
%   (2)
%   investment (FOC I)
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ni) = 1;%(1+bet)*s;
eq1(Ni) = 1/(1+bet);%s;
eq0(Nxi) = -bet/(1+bet);%-bet*s;
eq0(Nq) = -1/((1+bet)*s);%-1;
eq0(Nxui) = -bet;%-bet*s;
eq0(Nui) = 1;%s; normalized
g0(2,:) = eq0;
g1(2,:) = eq1;
Psi(2,:) = eq0ex;
%--------------------------------------------
%(3)	Q equation
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nq) = 1;
%eq0(Ntauc) = -tauc/(1+tauc);
eq0(NR) = 1;
eq0(Nxpi) = -1;
eq0(Nxq) = -bet*(1-delt);
eq0(Nxrk) = -bet*rk*(1-tauk)*(1+tauc);
eq0(Nxtk) = tauk*bet*rk*(1+tauc);
%eq0(Nxtc) = bet*tauc*(1-delt)/(1+tauc);
g0(3,:) = eq0;
g1(3,:) = eq1;
Psi(3,:) = eq0ex;
%--------------------------------------------
%(4)	Capital Accumulation Equation
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nk) = 1;
eq1(Nk) = 1-delt;
%eq0(Nv) = psi1;
eq0(Ni) = -delt;
g0(4,:) = eq0;
g1(4,:) = eq1;
Psi(4,:) = eq0ex;
%--------------------------------------------
%(5)	Phillips Equation
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
% eq0(Nppi) = 1;
% eq0(Nxppi) = -bet/(1 + bet*chip);
% eq1(Nppi) = chip/(1 + bet*chip);

eq0(Npi) = 1;
eq0(Nxpi) = -bet/(1 + bet*chip);
eq1(Npi) = chip/(1 + bet*chip);
eq0(Nrk) = -alph*(1/(1 + bet*chip))*(1-bet*omegap)*(1-omegap)*(1/omegap);
eq0(Nw) = -(1-alph)*(1/(1 + bet*chip))*(1-bet*omegap)*(1-omegap)*(1/omegap);
eq0(Nua) = (1/(1 + bet*chip))*(1-bet*omegap)*(1-omegap)*(1/omegap);
%eq1(Nkg) = -(1/(1 + bet*chip))*(1-bet*omegap)*(1-omegap)*(1/omegap)*(alphg);
%eq0(Ntauc) = -(tauc/(1+tauc))*(1/(1 + bet*chip))*(1-bet*omegap)*(1-omegap)*(1/omegap);
eq0(Nup) = -1;
g0(5,:) = eq0;
g1(5,:) = eq1;
Psi(5,:) = eq0ex;
%--------------------------------------------
%(6)	Wage Equation (L supply equation)
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nw) = 1 + (1/(1 + bet))*(1 - bet*omegaw)*(1-omegaw)*(1/omegaw)*(1/(1 + etaw*kappa));
eq0(Nxw) = -bet/(1+bet);
eq1(Nw) = 1/(1+bet);
eq0(Nxpi) = -bet/(1+bet);
eq0(Npi) = (1 + bet*chiw)/(1 + bet);
eq1(Npi) = chiw/(1 + bet);
eq0(Nl) = -kappa*(1/(1 + bet))*(1 - bet*omegaw)*(1-omegaw)*(1/omegaw)*(1/(1 + etaw*kappa));
eq0(Ncr) = -(gamm/(1-theta))*(((1-mu)*lambr)/((1-mu)*lambr + mu*lambnr))*(1/(1 + bet))*(1 - bet*omegaw)*(1-omegaw)*(1/omegaw)*(1/(1 + etaw*kappa));
eq1(Ncr) = -((gamm*theta)/(1-theta))*(((1-mu)*lambr)/((1-mu)*lambr + mu*lambnr))*(1/(1 + bet))*(1 - bet*omegaw)*(1-omegaw)*(1/omegaw)*(1/(1 + etaw*kappa));
eq0(Ncnr) = -gamm*((mu*lambnr)/((1-mu)*lambr + mu*lambnr))*(1/(1 + bet))*(1 - bet*omegaw)*(1-omegaw)*(1/omegaw)*(1/(1 + etaw*kappa));
eq0(Ntaul) = -(taul/(1-taul))*(1/(1 + bet))*(1 - bet*omegaw)*(1-omegaw)*(1/omegaw)*(1/(1 + etaw*kappa));
eq0(Nuw) = -1;
g0(6,:) = eq0;
g1(6,:) = eq1;
Psi(6,:) = eq0ex;
%--------------------------------------------
%(7)	Capital Demand Equation
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nkbar) = 1;
eq0(Ny) = -1;
eq0(Nw) = -(1-alph);
eq0(Nrk) = (1-alph);
eq0(Nua) = 1;
g0(7,:) = eq0;
g1(7,:) = eq1;
Psi(7,:) = eq0ex;
%--------------------------------------------
%(8)	Production Function
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ny) = 1;
eq0(Nua) = -1;
eq0(Nkbar) = -alph;
eq0(Nl) = -(1-alph);
g0(8,:) = eq0;
g1(8,:) = eq1;
Psi(8,:) = eq0ex;
%--------------------------------------------
%(9)	Taylor Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(NR) = 1;
eq1(NR) = rhor;
eq0(Npi) = -(1-rhor)*phipi - phipid;
eq0(Ny) = -(1-rhor)*phiy - phiyd;

eq1(Npi) = -phipid;
eq1(Ny) = -phiyd;
eq0(Nua) = phia;  %capture the effect on potential output.

eq0(Num) = -1;
g0(9,:) = eq0;
g1(9,:) = eq1;
Psi(9,:) = eq0ex;
%--------------------------------------------
%(10)	Consumption Aggregation
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nc) = c;
eq0(Ncr) = -(1-mu)*cr;
eq0(Ncnr) = -mu*cnr;
g0(10,:) = eq0;
g1(10,:) = eq1;
Psi(10,:) = eq0ex;
%--------------------------------------------
%(11)	Non-Ricardian Household's Budget
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ncnr) = cnr;
eq0(Nw) = -w*l*(1-taul);
eq0(Nl) = -w*l*(1-taul);
eq0(Ntaul) = w*l*taul;
eq0(Nz) = -z;
g0(11,:) = eq0;
g1(11,:) = eq1;
Psi(11,:) = eq0ex;
% %--------------------------------------------
% %(12)	Producer Inflation Defined
% %--------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Npi) = 1;
% eq0(Nppi) = -1;
% eq0(Ntauc) = -tauc/(1+tauc);
% eq1(Ntauc) = -tauc/(1+tauc);
% g0(12,:) = eq0;
% g1(12,:) = eq1;
% Psi(12,:) = eq0ex;
%--------------------------------------------
%(12)	sb Defined
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nsb) = 1;
eq0(Ny) = 1;
eq0(Nb) = -1;
g0(12,:) = eq0;
g1(12,:) = eq1;
Psi(12,:) = eq0ex;
%--------------------------------------------
%(13)	Aggregate Resouce Constraint
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ny) = 1;
eq0(Nc) = -cy;
eq0(Ni) = -delt*ky;
eq0(Ng) = -sg;
eq0(Nv) = -psi1*ky;

g0(13,:) = eq0;
g1(13,:) = eq1;
Psi(13,:) = eq0ex;
%--------------------------------------------
%(14)	Government Budget Constraint
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nb) = sb;
eq0(Ng) = -sg;
eq0(Ntauk) = tauk*rk*ky;
eq0(Nrk) = tauk*rk*ky;
eq0(Nv) = tauk*rk*ky;
eq0(Ntaul) = taul*w*ly;
eq0(Nw) = taul*w*ly;
eq0(Nl) = taul*w*ly;
%eq0(Nc) = (tauc*cy)/(1+tauc);
%eq0(Ntauc) = (tauc*cy)/((1+tauc)^2);
eq0(Nz) = -str;
eq0(Npi) = R*sb; 
eq1(NR) = R*sb;
eq1(Nb) = R*sb;
eq1(Nk) = -tauk*rk*ky;
g0(14,:) = eq0;
g1(14,:) = eq1;
Psi(14,:) = eq0ex; 
%--------------------------------------------
%(15)    g Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ng) = 1;
eq1(Nsb) = -(1-rhog)*gammg;
eq1(Ng) = rhog;
eq0(Nug) = -1;
g0(15,:) = eq0;
g1(15,:) = eq1;
Psi(15,:) = eq0ex;
%--------------------------------------------
%(16)    Capital Tax Rate Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ntauk) = 1;
eq0(Ny) = -(1-rhotk)*psitk;
eq1(Nsb) = (1-rhotk)*gammtk;
eq1(Ntauk) = rhotk;
eq0(Nutk) = -(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutk) = ma1;
eq1(Nf1k) = ma2;
eq1(Nf2k) = ma3;
eq1(Nf3k) = ma4;
eq1(Nf4k) = ma5;
eq1(Nf5k) = ma6;
eq1(Nf6k) = ma7;
eq1(Nf7k) = ma8;

eq0(Nutl) = -cor*(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutl) = cor*ma1;
eq1(Nf1l) = cor*ma2;
eq1(Nf2l) = cor*ma3;
eq1(Nf3l) = cor*ma4;
eq1(Nf4l) = cor*ma5;
eq1(Nf5l) = cor*ma6;
eq1(Nf6l) = cor*ma7;
eq1(Nf7l) = cor*ma8;


g0(16,:) = eq0;
g1(16,:) = eq1;
Psi(16,:) = eq0ex;
%--------------------------------------------
%(17)    Labor Tax Rate Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ntaul) = 1;
eq0(Ny) = -(1-rhotl)*psitl;
eq1(Nsb) = (1-rhotl)*gammtl;
eq1(Ntaul) = rhotl;
eq0(Nutl) = -(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutl) = ma1;
eq1(Nf1l) = ma2;
eq1(Nf2l) = ma3;
eq1(Nf3l) = ma4;
eq1(Nf4l) = ma5;
eq1(Nf5l) = ma6;
eq1(Nf6l) = ma7;
eq1(Nf7l) = ma8;

eq0(Nutk) = -cor*(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutk) = cor*ma1;
eq1(Nf1k) = cor*ma2;
eq1(Nf2k) = cor*ma3;
eq1(Nf3k) = cor*ma4;
eq1(Nf4k) = cor*ma5;
eq1(Nf5k) = cor*ma6;
eq1(Nf6k) = cor*ma7;
eq1(Nf7k) = cor*ma8;



g0(17,:) = eq0;
g1(17,:) = eq1;
Psi(17,:) = eq0ex;
% %--------------------------------------------
% %(19)    Consumption Tax Rate Rule
% %--------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Ntauc) = 1;
% eq1(Ntauc) = rhotc;
% eq0(Nutc) = -1;
% g0(19,:) = eq0;
% g1(19,:) = eq1;
% Psi(19,:) = eq0ex;
%--------------------------------------------
%(18)    Z Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nz) = 1;
eq0(Ny) = (1-rhoz)*psiz;
eq1(Nsb) = -(1-rhoz)*gammz;
eq1(Nz) = rhoz;
eq0(Nuz) = -1;
g0(18,:) = eq0;
g1(18,:) = eq1;
Psi(18,:) = eq0ex;
%--------------------------------------------
%(19)	v equation
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nv) = gpsi/(1-gpsi);
eq0(Nrk) = -1;
eq0(Ntauk) = tauk/(1-tauk);
%eq0(Nq) = 1;
%eq0(Ntauc) = -tauc/(1+tauc);
g0(19,:) = eq0;
g1(19,:) = eq1;
Psi(19,:) = eq0ex;
%--------------------------------------------
%(20)	kbar, effective unit of capital
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nkbar) = 1;
eq1(Nk) = 1;
eq0(Nv) = -1;
g0(20,:) = eq0;
g1(20,:) = eq1;
Psi(20,:) = eq0ex;
%--------------------------------------------
%(21)	Define Xpi
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Npi) = 1;
eq1(Nxpi) = 1;
g0(21,:) = eq0;
g1(21,:) = eq1;
Psi(21,:) = eq0ex;
Pie(21,1) = 1;
%--------------------------------------------
%(22)	Define Xw
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nw) = 1;
eq1(Nxw) = 1;
g0(22,:) = eq0;
g1(22,:) = eq1;
Psi(22,:) = eq0ex;
Pie(22,2) = 1;
%--------------------------------------------
%(23)	Define Xq
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nq) = 1;
eq1(Nxq) = 1;
g0(23,:) = eq0;
g1(23,:) = eq1;
Psi(23,:) = eq0ex;
Pie(23,3) = 1;
%--------------------------------------------
%(24)	Define Xrk
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nrk) = 1;
eq1(Nxrk) = 1;
g0(24,:) = eq0;
g1(24,:) = eq1;
Psi(24,:) = eq0ex;
Pie(24,4) = 1;
%--------------------------------------------
%(25)	Define Xui
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nui) = 1;
eq1(Nxui) = 1;
g0(25,:) = eq0;
g1(25,:) = eq1;
Psi(25,:) = eq0ex;
Pie(25,5) = 1;
%--------------------------------------------
%(26)	Define XI
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ni) = 1;
eq1(Nxi) = 1;
g0(26,:) = eq0;
g1(26,:) = eq1;
Psi(26,:) = eq0ex;
Pie(26,6) = 1;
%--------------------------------------------
%(27)	Define XCR
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ncr) = 1;
eq1(Nxcr) = 1;
g0(27,:) = eq0;
g1(27,:) = eq1;
Psi(27,:) = eq0ex;
Pie(27,7) = 1;
%--------------------------------------------
%(28)	Define Xub
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nub) = 1;
eq1(Nxub) = 1;
g0(28,:) = eq0;
g1(28,:) = eq1;
Psi(28,:) = eq0ex;
Pie(28,8) = 1;
% %--------------------------------------------
% %(31)	Define Xtauc
% %--------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Ntauc) = 1;
% eq1(Nxtc) = 1;
% g0(31,:) = eq0;
% g1(31,:) = eq1;
% Psi(31,:) = eq0ex;
% Pie(31,9) = 1;
%--------------------------------------------
%(29)	Define Xtk
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ntauk) = 1;
eq1(Nxtk) = 1;
g0(29,:) = eq0;
g1(29,:) = eq1;
Psi(29,:) = eq0ex;
Pie(29,9) = 1;
% %--------------------------------------------
% %(30)	Define Xppi
% %--------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Nppi) = 1;
% eq1(Nxppi) = 1;
% g0(30,:) = eq0;
% g1(30,:) = eq1;
% Psi(30,:) = eq0ex;
% Pie(30,10) = 1;
%--------------------------------------------
%(30)	Fisher Equation: real interest rate checking
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nr) = 1;
eq0(NR) = -1;
eq0(Nxpi) = 1;
g0(30,:) = eq0;
g1(30,:) = eq1;
Psi(30,:) = eq0ex;
%--------------------------------------------
%(31)	real mc
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nmc) = 1;
eq0(Nw) = -(1-alph);
eq0(Nrk) = -alph;
eq0(Nua) = 1;
%eq1(Nkg) = -alphg;
g0(31,:) = eq0;
g1(31,:) = eq1;
Psi(31,:) = eq0ex;
% %--------------------------------------------
% %(36)	Consumption Tax Revenue
% %--------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(NTc) = 1;
% eq0(Ntauc) = -1/(1+tauc);
% eq0(Nc) = -1;
% g0(36,:) = eq0;
% g1(36,:) = eq1;
% Psi(36,:) = eq0ex;
%--------------------------------------------
%(32)	Capital Tax Revenue
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(NTk) = 1;
eq0(Ntauk) = -1;
eq0(Nrk) = -1;
eq0(Nkbar) = -1;
g0(32,:) = eq0;
g1(32,:) = eq1;
Psi(32,:) = eq0ex;
%--------------------------------------------
%(33)	Labor Tax Revenue
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(NTl) = 1;
eq0(Ntaul) = -1;
eq0(Nw) = -1;
eq0(Nl) = -1;
g0(33,:) = eq0;
g1(33,:) = eq1;
Psi(33,:) = eq0ex;
%--------------------------------------------
%(34)	Income Tax Revenue
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nrev) = rev;
eq0(NTk) = -tk;
eq0(NTl) = -tl;
g0(34,:) = eq0;
g1(34,:) = eq1;
Psi(34,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (35)
%    f1k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf1k) = 1;
eq1(Nutk) = 1;
g0(35,:) = eq0;
g1(35,:) = eq1;
Psi(35,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (36)
%    f2k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf2k) = 1;
eq1(Nf1k) = 1;
g0(36,:) = eq0;
g1(36,:) = eq1;
Psi(36,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (37)
%    f3k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf3k) = 1;
eq1(Nf2k) = 1;
g0(37,:) = eq0;
g1(37,:) = eq1;
Psi(37,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (38)
%    f4k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf4k) = 1;
eq1(Nf3k) = 1;
g0(38,:) = eq0;
g1(38,:) = eq1;
Psi(38,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (39)
%    f5k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf5k) = 1;
eq1(Nf4k) = 1;
g0(39,:) = eq0;
g1(39,:) = eq1;
Psi(39,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (40)
%    f6k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf6k) = 1;
eq1(Nf5k) = 1;
g0(40,:) = eq0;
g1(40,:) = eq1;
Psi(40,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (41)
%    f7k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf7k) = 1;
eq1(Nf6k) = 1;
g0(41,:) = eq0;
g1(41,:) = eq1;
Psi(41,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (42)
%    f1l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf1l) = 1;
eq1(Nutl) = 1;
g0(42,:) = eq0;
g1(42,:) = eq1;
Psi(42,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (43)
%    f2l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf2l) = 1;
eq1(Nf1l) = 1;
g0(43,:) = eq0;
g1(43,:) = eq1;
Psi(43,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (44)
%    f3l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf3l) = 1;
eq1(Nf2l) = 1;
g0(44,:) = eq0;
g1(44,:) = eq1;
Psi(44,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (45)
%    f4l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf4l) = 1;
eq1(Nf3l) = 1;
g0(45,:) = eq0;
g1(45,:) = eq1;
Psi(45,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (46)
%    f5l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf5l) = 1;
eq1(Nf4l) = 1;
g0(46,:) = eq0;
g1(46,:) = eq1;
Psi(46,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (47)
%    f6l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf6l) = 1;
eq1(Nf5l) = 1;
g0(47,:) = eq0;
g1(47,:) = eq1;
Psi(47,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (48)
%    f7l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf7l) = 1;
eq1(Nf6l) = 1;
g0(48,:) = eq0;
g1(48,:) = eq1;
Psi(48,:) = eq0ex;
%--------------------------------------------
%(49)	Tech Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nua) = 1;
eq1(Nua) = rhoa;
eq0ex(Nua) = siga;
g0(49,:) = eq0;
g1(49,:) = eq1;
Psi(49,:) = eq0ex;
%--------------------------------------------
%(50)	Preference Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nub) = 1;
eq1(Nub) = rhob;
eq0ex(Nub) = sigb;
g0(50,:) = eq0;
g1(50,:) = eq1;
Psi(50,:) = eq0ex;
%--------------------------------------------
%(51)	Monetary Policy Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Num) = 1;
eq0ex(Num) = sigm;
g0(51,:) = eq0;
g1(51,:) = eq1;
Psi(51,:) = eq0ex;
%--------------------------------------------
%(52)	Investment Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nui) = 1;
eq1(Nui) = rhoi;
eq0ex(Nui) = sigi;
g0(52,:) = eq0;
g1(52,:) = eq1;
Psi(52,:) = eq0ex;
%--------------------------------------------
%(53)	wage markup Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nuw) = 1;
eq1(Nuw) = rhow;
eq0ex(Nuw) = sigw;
g0(53,:) = eq0;
g1(53,:) = eq1;
Psi(53,:) = eq0ex;
%--------------------------------------------
%(54)	price markup Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nup) = 1;
eq1(Nup) = rhop;
eq0ex(Nup) = sigp;
g0(54,:) = eq0;
g1(54,:) = eq1;
Psi(54,:) = eq0ex;
%--------------------------------------------
%(55)	g Spending Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nug) = 1;
eq0ex(Nug) = sigg;
g0(55,:) = eq0;
g1(55,:) = eq1;
Psi(55,:) = eq0ex;
%--------------------------------------------
%(56)	tk Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nutk) = 1;
eq0ex(Nutk) = sigtk;
g0(56,:) = eq0;
g1(56,:) = eq1;
Psi(56,:) = eq0ex;
%--------------------------------------------
%(57)	tl Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nutl) = 1;
eq0ex(Nutl) = sigtl;
g0(57,:) = eq0;
g1(57,:) = eq1;
Psi(57,:) = eq0ex;
% %--------------------------------------------
% %(48)	tauc Shock
% %--------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Nutc) = 1;
% eq0ex(Nutc) = sigtc;
% g0(48,:) = eq0;
% g1(48,:) = eq1;
% Psi(48,:) = eq0ex;
%--------------------------------------------
%(58)	Z Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nuz) = 1;
eq0ex(Nuz) = sigz;
g0(58,:) = eq0;
g1(58,:) = eq1;
Psi(58,:) = eq0ex;


