function [detrend_data,H] = data_detrend(obs,nvar)

load data 
d1 = find(data(:,19) == 1984.1);  
d2 = find(data(:,19) == 2007.4);  
data = data(d1:d2,:);

C = (data(:,1));
I = (data(:,2));
Y = (data(:,3));
L = (data(:,4));
GC = (data(:,5));
GI = (data(:,6));
Tl = (data(:,7)); 
Tk = (data(:,8));
Tc = (data(:,9));
B = (data(:,10));
Z = (data(:,11));
Pi = (data(:,12));
w = (data(:,13));
R = (data(:,14));
Tauk = (data(:,15));
Taul = (data(:,16));
Tauc = (data(:,17));
G = (data(:,18));

% removes constant and linear trend
Ct = detrend(C,1); 
It = detrend(I,1);
wt = detrend(w,1);
Yt = detrend(Y,1);
Lt = detrend(L,1);
GCt = detrend(GC,1);
GIt = detrend(GI,1);
Bt = detrend(B,1);
Tkt = detrend(Tk,1);
Tlt = detrend(Tl,1);
Tct = detrend(Tc,1);
Taukt = detrend(Tauk,1);
Tault = detrend(Taul,1);
Tauct = detrend(Tauc,1);
Zt = detrend(Z,1);
Gt = detrend(G,1);

Pi1 =Pi - mean(Pi);
pit = detrend(Pi1,1);
pitrend = Pi1-pit;
Rdemean = R-mean(R);
Rt = Rdemean - pitrend;

detrend_data = [It Ct Rt Tlt Tkt Gt Zt Lt pit wt];
detrend_data = detrend_data';

nobs = size(obs,1);
H = zeros(nobs,nvar);

H(1,obs(1,1)) = 1;
H(2,obs(2,1)) = 1;
H(3,obs(3,1)) = 1;
H(4,obs(4,1)) = 1;
H(5,obs(5,1)) = 1;
H(6,obs(6,1)) = 1;
H(7,obs(7,1)) = 1;
H(8,obs(8,1)) = 1;
H(9,obs(9,1)) = 1;
H(10,obs(10,1)) = 1;

