function [obsdata,H] = gendata(G,M,obs,nvar)
% function [obsdata,H] = gendata(G,M,obs)
% This function generates simulated data for the model.  
% This is conditional on determinacy.

simlength = 10000;
burn = 9500;
nobs = size(obs,1);

epsvec = zeros(nobs,simlength);

for i = 1:simlength
    epsvec(:,i) = randn(nobs,1);
end

gendata = zeros(nvar,simlength);

for i = 2:simlength
    gendata(:,i) = G*gendata(:,i-1) + M*epsvec(:,i);
end

gendata = gendata(:,burn+1:simlength);

% Generate the "observed" data.
obsdata = zeros(nobs,size(gendata,2));

H = zeros(nobs,nvar);

H(1,obs(1,1)) = 1;
H(2,obs(2,1)) = 1;
H(3,obs(3,1)) = 1;
H(4,obs(4,1)) = 1;
H(5,obs(5,1)) = 1;
H(6,obs(6,1)) = 1;
H(7,obs(7,1)) = 1;
H(8,obs(8,1)) = 1;
H(9,obs(9,1)) = 1;
H(10,obs(10,1)) = 1;
%H(11,obs(11,1)) = 1;

for i = 1:size(gendata,2)
    obsdata(:,i) = H*gendata(:,i);
end

obsdata = obsdata(:,end-99:end);
