function [igpdf] = invgampdf(x,alpha,beta)
% function [igpdf] = invgampdf(x,alpha,beta)
% Computes inverse gamma pdf at point x for given shape parameter alpha and
% scale parameter beta.
% Nora Traum
% Last Updated: June 25, 2008

if x <= 0
    igpdf = 0;
else
g = gamma(alpha);
igpdf = ((beta^(alpha))/g)*((1/x)^(alpha+1))*exp(-beta/x);
end