function [p] = priors(Theta)
% function [p] = priors(Theta)
% Evaluates the prior for the NK fiscal policy model 
% Nora Traum, Indiana University
% Last Updated June 21, 2009

Theta = Theta';
p = 0;


p = log(gampdf(Theta(1,1),25,0.06)) + p; % prior on gamma (1.5,0.3) 

p = log(gampdf(Theta(2,1),16,0.125)) + p; % prior on kappa gamma(2,.5)

%p = log(betapdf(Theta(3,1),9.2,13.8)) + p; % prior on omegaw (.4, .1)
p = log(betapdf(Theta(3,1),12,12)) + p; % prior on omegaw (0.5, 0.1)

%p = log(betapdf(Theta(4,1),9.2,13.8)) + p; % prior on omegap (.4, .1)
p = log(betapdf(Theta(4,1),12,12)) + p; % prior on omegap (0.5, 0.1)
%p = log(betapdf(Theta(4,1),5.055556,5.055556)) + p; % prior on omegap (0.5, 0.15)
%p = log(betapdf(Theta(4,1),3.866667,5.8)) + p; % prior on omegap (0.4, 0.15)

%p = log(betapdf(Theta(5,1),49.5,49.5)) + p; % prior on mu (0.5, .05)
%p = log(betapdf(Theta(5,1),19.03125,19.03125)) + p; % prior on mu (0.5, .07)
%p = log(betapdf(Theta(5,1),12,12)) + p; % prior on mu (0.5, 0.1)
%p = log(betapdf(Theta(5,1),5.4687,12.7616)) + p; % prior on mu (0.3, 0.1)
%p = log(betapdf(Theta(5,1),5.055556,5.055556)) + p; % prior on mu (0.5, 0.15)

%p = log(normpdf(Theta(6,1),1.6,0.25)) + p; % prior on phipi
p = log(normpdf(Theta(5,1),1.5,0.25)) + p; % prior on phipi

p = log(normpdf(Theta(6,1),0.12,0.05)) + p; % prior on phiY   

p = log(betapdf(Theta(7,1),5.0555556,5.0555556)) + p; % prior on habit (.5,.15)
%p = log(betapdf(Theta(7,1),12,12)) + p; % prior on habit (.5,.1)
%p = log(betapdf(Theta(8,1),14,6)) + p; % prior on habit (.7,.1)
%p = log(betapdf(Theta(8,1),13.8,9.2)) + p; % prior on habit (0.6, 0.1)

%p = log(betapdf(Theta(9,1),2.6250,2.6250)) + p; % prior on psi
p = log(betapdf(Theta(8,1),5.055556,5.055556)) + p; % prior on psi (.5, .15)
%p = log(betapdf(Theta(8,1),5.8,3.666667)) + p; % prior on psi (.6, .15)

p = log(normpdf(Theta(9,1),4,1.5)) + p; % prior on s 

%p = log(betapdf(Theta(11,1),1.275,2.975)) + p; % prior on chiw
p = log(betapdf(Theta(10,1),5.055556,5.055556)) + p; %prior on chiw

%p = log(betapdf(Theta(12,1),1.275,2.975)) + p; % prior on chip
p = log(betapdf(Theta(11,1),5.055556,5.055556)) + p; %prior on chip


p = log(betapdf(Theta(12,1),2.625,2.625)) + p; % prior on tech serial correlation (.5,.2)
p = log(betapdf(Theta(13,1),2.625,2.625)) + p; % prior on cons. serial correlation
p = log(betapdf(Theta(14,1),2.625,2.625)) + p; % prior on monetary policy serial correlation
p = log(betapdf(Theta(15,1),2.625,2.625)) + p; % prior on investment serial correlation  
p = log(betapdf(Theta(16,1),2.625,2.625)) + p; % prior on wage markup serial correlation
p = log(betapdf(Theta(17,1),2.625,2.625)) + p; % prior on price markup serial correlation
p = log(betapdf(Theta(18,1),2.625,2.625)) + p; % prior on gov. consumption serial correlation
%p = log(betapdf(Theta(19,1),2.625,2.625)) + p; % prior on gov. investment serial correlation
p = log(betapdf(Theta(19,1),2.625,2.625)) + p; % prior on tauk serial correlation
p = log(betapdf(Theta(20,1),2.625,2.625)) + p; % prior on taul serial correlation
%p = log(betapdf(Theta(21,1),2.625,2.625)) + p; % prior on tauc serial correlation
p = log(betapdf(Theta(21,1),2.625,2.625)) + p; % prior on transfer serial correlation

%p = log(gampdf(Theta(25,1),4,.05)) + p;     %prior on gov. consumption debt parameter (0.2,0.1)
p = log(normpdf(Theta(22,1),.15,.05)) + p;    %prior on gov. consumption debt parameter

%p = log(gampdf(Theta(27,1),4,.05)) + p; % prior on tauk debt parameter (.2,.1)
%p = log(normpdf(Theta(23,1),.15,.1)) + p; % prior on tauk debt parameter

%p = log(gampdf(Theta(28,1),4,.15)) + p; % prior on taul debt parameter (.6,.3) 
%p = log(gampdf(Theta(28,1),.2,.1)) + p; % prior on taul debt parameter (.2,.1) 
%p = log(normpdf(Theta(24,1),.15,.1)) + p; % prior on taul debt parameter  

%p = log(gampdf(Theta(29,1),100,.01)) + p; % prior on z debt parameter
p = log(normpdf(Theta(23,1),.15,.05)) + p; % prior on z debt parameter
%p = log(gampdf(Theta(29,1),4,.05)) + p; % prior on z debt parameter (.2,.1)
%p = log(gampdf(Theta(29,1),4,.25)) + p; % prior on z debt parameter (1,.5)


%p = log(gampdf(Theta(26,1),4.5918,0.1633)) + p; % prior on tauk elasticity (1,.3)  
%p = log(gampdf(Theta(30,1),4,.25)) + p; % prior on tauk elasticity (1,.5)   
%%p = log(normpdf(Theta(30,1),1,0.3)) + p; % prior on tauk elasticity    

%p = log(gampdf(Theta(31,1),25,.02)) + p; % prior on taul elasticity (.5,.1)
%p = log(gampdf(Theta(31,1),4,.0125)) + p; % prior on taul elasticity (.5,.25)
%%p = log(gampdf(Theta(31,1),6.25,.08)) + p; % prior on taul elasticity (.5,.2)
%p = log(gampdf(Theta(27,1),4,0.1)) + p; % prior on taul elasticity (.5,.2)
%p = log(normpdf(Theta(31,1),.5,.2)) + p; % prior on taul elasticity

p = log(invgampdf(Theta(24,1),2.0025,0.10025)) + p; % prior on tech precision (.1,2)
p = log(invgampdf(Theta(25,1),2.0025,0.10025)) + p; % prior on cons. precision
p = log(invgampdf(Theta(26,1),2.0025,0.10025)) + p; % prior on money precision
p = log(invgampdf(Theta(27,1),2.0025,0.10025)) + p; % prior on investment precision
p = log(invgampdf(Theta(28,1),2.0025,0.10025)) + p; % prior on wage markup precision
p = log(invgampdf(Theta(29,1),2.0025,0.10025)) + p; % prior on price markup precision
p = log(invgampdf(Theta(30,1),2.0025,0.10025)) + p; % prior on gov. consumption precision
%p = log(invgampdf(Theta(38,1),2,1)) + p; % prior on gov. investment precision
p = log(invgampdf(Theta(31,1),2.0025,0.10025)) + p; % prior on tauk precision
p = log(invgampdf(Theta(32,1),2.0025,0.10025)) + p; % prior on taul precision
%p = log(invgampdf(Theta(38,1),2,1)) + p; % prior on tauc precision
p = log(invgampdf(Theta(33,1),2.0025,0.10025)) + p; % prior on transfer precision

% p = log(normpdf(Theta(34,1),0.3,0.1)) + p; % prior on phipid
 p = log(normpdf(Theta(34,1),0.12,0.05)) + p; % prior on phiyd
% p = log(normpdf(Theta(36,1),0.0625,0.05)) + p; % prior on phiyd




% Note: for estimation with real data, some of the precision priors will
% need to be changed.  Need to experiment with this.



