function [IRFa,IRFe,bbb,ddd,L] = ABCD_Kfilter(A,B,C,D,A0,TTT)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% If Invertibility Condition Not Satisfied 
% Calculate Econometrician's IRF 
% State Space Must be in ABCD-Form (see Fernandez et al. )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% warning off; % D matrix close to singular; 

%  % %   Hansen-Sargent m files        
%          [k,s] = kfilter(A,C,B*B',D*D',B*D'); 
%     varin=C*s*C'+D*D';  % Innovation Variance
%     bb=k; 
%     dd=eye(size(D)); 
 
% %    % % Using Matlab control toolbox 
    sys=ss(A,[zeros(size(B)),B],C,[zeros(size(D)),D],-1);
    QN=A0; RN=1e-10*eye(size(D)); NN=1e-10*eye(size(D)); % Instead of zeros to keep kfilter from choking
    [Kest,L,P]=kalman(sys,QN,RN,NN); 
    varin=C*P*C'+D*D'; %Innovation Variance Not orthogonal
    bb=L;
    dd=eye(length(D)); % Must be Identity for Innovations Rep 
   
%%%%
% % Identification of shocks
 rs=chol(varin);
 size(rs);
 size(bb);
 bbb=bb*rs';
 ddd=dd*rs';
 
 
%    TTT=21; 
   for i=1:1:length(D)
  IRFa(:,:,i)=dimpulse(A,B,C,D,i,TTT);
  IRFe(:,:,i)=dimpulse(A,bbb,C,ddd,i,TTT) ;
   end
 
% D=eye(2,2);  
%   sys=ss(A,[zeros(size(B)),B],C,[zeros(size(DD)),DD],-1);
%   QN=eye(2); RN=zeros(2); NN=zeros(2);  
%   [Kest,L,P,M,Z]=kalman(sys,QN,RN,NN); 
%   VarInnov=C*P*C'+DD*DD'; % Not orthogonal
%   % % Orthogonalize Innovations
%   bb=L; 
%   dd=D; 
%  rs=chol(VarInnov);
%  bbb=bb*rs';
%  ddd=dd*rs';
% IRF_ke=dimpulse(A,bbb,C,ddd,2,T); 
% IRF_ke=IRF_ke(:,2)
%    bbb=bb*D; 
%    ddd=dd*D;


    
   
