function [g0,g1,Psi,Pie,CC,ss,exitflag] = modelnogrowth(param,nvar,nforerrors,ma1,ma2,ma3,ma4,ma5,ma6,ma7,ma8,cor)
%----------------------------------
% Set Parameters
%----------------------------------
pnames = { 	'alph  '   	% 
            'bet   '    % 
            'gamm  '  	% 1
            'kappa'     % 2
            'sg'        % 
            'phi'        % 
            'taul'		% 
            'tauk'      % 
            'delt'      % 
            'rhoa'		%12
            'rhog'		%18
            'rhotk'     %19
            'rhotl'     %20
            'rhoz'      %21
            'gammg'	    %22
            'gammtk'	%23
            'gammtl'    %24
            'gammz'     %25
            'psitk'     %26
            'psitl'     %27           
            'siga'      %28    
            'sigg'      %34
            'sigtk'     %35
            'sigtl'     %36
            'sigz'      %37
            'cor'
            
            'ma1'       %25
            'ma2'       %26
            'ma3'       %27
            'ma4'       %28
            'ma5'       %29
            'ma6'       %30
            'ma7'       %31
            'ma8'       %32
           
            
};      

parameter = [ 0.36% 0.36             %    alph: capital share
            0.99%0.99                %    bet: time preference
            1%param(1,1)       	% 1. gamm: curvature over consumption
            1%param(1,2)        % 2. kappa: curvature over leisure
            0.2%.0698+.00395    %    sg:  
            1.6                 %    phi
            0.24%.362%0.24               %    taul 
            0.36%.183%0.36              %    tauk 
           0.025%.025                %    delt: k depreciation
           0.9%param(1,12)          % 12.rhoa: serial correlation on A 
           0.9%param(1,18)          % 18.rhog: serial correlation on GC
           0.9%param(1,19)          % 19.rhotk: serial correlation on tauk
           0.9%param(1,20)          % 20.rhotl: serial correlation on taul
           0.9%param(1,21)          % 21.rhoz: serial correlation on transfers
           param(1,22)          % 22.gammg: response of G to debt; 
           0%param(1,23)          % 23.gammtk: response of capital tax revenue to debt; 
           0%param(1,24)        % 24.gammtl: response of labor tax revenue to debt
           param(1,23)          % 25.gammz: response of transfers to debt
           0                    % 26.psitk
           0                    % 27.psitl
           param(1,24)          % 28.a sigma
           param(1,30)          % 34.g sigma
           param(1,31)          % 35.tk sigma
           param(1,32)          % 36.tl sigma
           param(1,33)          % 37.z sigma
           cor

           ma1                  % ma1
           ma2                  % ma2
           ma3                  % ma3
           ma4                  % ma4
           ma5                  % ma5
           ma6                  % ma6
           ma7                  % ma7   
           ma8                  % ma8
                   ];
            
for j = 1:length(parameter)
    eval([char(pnames(j,:)) '=parameter(j);']);
end
%Solve for the steady state

R = 1/bet;
rk = (1 - bet*(1 - delt))/(bet*(1 - tauk));


X(1) = 0.5;%18643;10
X(2) = 0.59;
X(3) = .17;

%Solve w, k/y, l/y, c/y, y jointly
options = optimset('Display','off','MaxIter',100000,'TolFun',1e-7);
[X,fval,exitflag] = fsolve(@ssNLEst,X,options,parameter);
exitflag
l = X(1);
k = X(2);
c = X(3);

y = k^alph*l^(1-alph);
w= (1-alph)*y/l;
iv = delt*k;
tk = rk*k*tauk;
tl = w*l*taul;
st = (- sg + tk/y + tl/y);
z = st*y;
g = sg*y;
rev = tk + tl;
nr = (1-tauk)*alph*y/k+1-delt;
ss = [c iv y l tk tl g rev k R];


% Load variables
variables

g0 = zeros(nvar,nvar);
g1 = g0;
CC = zeros(nvar,1);
Psi = zeros(nvar,nvar);
Pie = zeros(nvar,nforerrors);
%-------------------------------------------------------------------------------
%   (1)
%   Aggregate Resource Constraint
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nc) = c;
eq0(Nk) = k;
eq0(Ny) = -y;
eq0(Ng) = g;
eq1(Nk) = (1-delt)*k;
g0(1,:) = eq0;
g1(1,:) = eq1;
Psi(1,:) = eq0ex;
%-------------------------------------------------------------------------------
%   (2)
%   Production Function
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ny) = 1;
eq0(Nl) = -(1-alph);
eq1(Nk) = alph;
eq0(Nua) = -1;
g0(2,:) = eq0;
g1(2,:) = eq1;
Psi(2,:) = eq0ex;
%-------------------------------------------------------------------------------
%   (3)
%   Euler equation for k
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nc) = -gamm;
eq0(Nnr) = 1;
eq1(Nc) = -gamm;
g0(3,:) = eq0;
g1(3,:) = eq1;
Pie(3,1) = 1.0;
Psi(3,:) = eq0ex;
%-------------------------------------------------------------------------------
%   (4)
%	net return to capital (NR)   
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ny) = -(alph*y/k)*(1-tauk);
eq0(Nnr) = nr;
eq0(Ntauk) = tauk*alph*y/k;
eq1(Nk) = -(alph*y/k)*(1-tauk);
g0(4,:) = eq0;
g1(4,:) = eq1;
Psi(4,:) = eq0ex;
%--------------------------------------------
%(5)	Capital Accumulation Equation
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nk) = 1;
eq1(Nk) = 1-delt;
eq0(Ni) = -delt;
g0(5,:) = eq0;
g1(5,:) = eq1;
Psi(5,:) = eq0ex;
%-------------------------------------------------------------------------------
%   (6)
%	interest rate (R)   
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nc) = -gamm;
eq1(Nc) = -gamm;
eq1(Nr) = -1;
g0(6,:) = eq0;
g1(6,:) = eq1;
Pie(6,2) = 1;
Psi(6,:) = eq0ex;
%-------------------------------------------------------------------------------
%   (7)
%   FOC for Labor Supply
%-------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nl) = 1+kappa*l/(1-l);%1+kappa;
eq0(Nc) = gamm;
eq0(Ny) = -1;
eq0(Ntaul) = taul/(1-taul);
g0(7,:) = eq0;
g1(7,:) = eq1;
Psi(7,:) = eq0ex;
%---------------------------------------------------------------------------------
%   (8)
%   gbc
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ng) = g;
eq0(Ny) = -y*(taul*(1-alph)+tauk*alph);
eq0(Ntaul)= -taul*y*(1-alph);
eq0(Ntauk) = -tauk*y*alph;
%eq0(Nb) = -b;
eq0(Nz) = z;
%eq1(Nr) = -R*b; 
%eq1(Nb) = -R*b; 
g0(8,:) = eq0;
g1(8,:) = eq1;
Psi(8,:) = eq0ex;
%---------------------------------------------------------------------------------
%   (9)
%   government spending (g=sg*y)
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ng) = 1;
eq0(Nsg) = -1;
eq0(Ny) = -1;
g0(9,:) = eq0;
g1(9,:) = eq1;
Psi(9,:) = eq0ex;
% %-------------------------------------------------------------------------------
% %   (10)
% %   debt output ratio (sb=b/y)
% %--------------------------------------------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Nsb) = 1;
% eq0(Nb) = -1;
% eq0(Ny) = 1;
% g0(10,:) = eq0;
% g1(10,:) = eq1;
% Psi(10,:) = eq0ex;
% %-------------------------------------------------------------------------------
% %   (11)
% %   transfer output ratio
% %--------------------------------------------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Nz) = 1;
% eq1(Nsb) = -(1-rhoz)*gammz;
% eq1(Nz) = rhoz;
% eq0(Nuz) = -1;
% g0(10,:) = eq0;
% g1(10,:) = eq1;
% Psi(10,:) = eq0ex;
%--------------------------------------------
%(12)    g Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ng) = 1;
%eq1(Nsb) = -(1-rhog)*gammg;
eq1(Ng) = rhog;
eq0(Nug) = -1;
g0(10,:) = eq0;
g1(10,:) = eq1;
Psi(10,:) = eq0ex;
%--------------------------------------------
%(13)    Capital Tax Rate Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ntauk) = 1;
eq0(Ny) = -(1-rhotk)*psitk;
%eq1(Nsb) = (1-rhotk)*gammtk;
eq1(Ntauk) = rhotk;
eq0(Nutk) = -(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutk) = ma1;
eq1(Nf1k) = ma2;
eq1(Nf2k) = ma3;
eq1(Nf3k) = ma4;
eq1(Nf4k) = ma5;
eq1(Nf5k) = ma6;
eq1(Nf6k) = ma7;
eq1(Nf7k) = ma8;

eq0(Nutl) = -cor*(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutl) = cor*ma1;
eq1(Nf1l) = cor*ma2;
eq1(Nf2l) = cor*ma3;
eq1(Nf3l) = cor*ma4;
eq1(Nf4l) = cor*ma5;
eq1(Nf5l) = cor*ma6;
eq1(Nf6l) = cor*ma7;
eq1(Nf7l) = cor*ma8;


g0(11,:) = eq0;
g1(11,:) = eq1;
Psi(11,:) = eq0ex;
%--------------------------------------------
%(14)    Labor Tax Rate Rule
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Ntaul) = 1;
eq0(Ny) = -(1-rhotl)*psitl;
%eq1(Nsb) = (1-rhotl)*gammtl;
eq1(Ntaul) = rhotl;
eq0(Nutl) = -(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutl) = ma1;
eq1(Nf1l) = ma2;
eq1(Nf2l) = ma3;
eq1(Nf3l) = ma4;
eq1(Nf4l) = ma5;
eq1(Nf5l) = ma6;
eq1(Nf6l) = ma7;
eq1(Nf7l) = ma8;

eq0(Nutk) = -cor*(1-ma1-ma2-ma3-ma4-ma5-ma6-ma7-ma8);
eq1(Nutk) = cor*ma1;
eq1(Nf1k) = cor*ma2;
eq1(Nf2k) = cor*ma3;
eq1(Nf3k) = cor*ma4;
eq1(Nf4k) = cor*ma5;
eq1(Nf5k) = cor*ma6;
eq1(Nf6k) = cor*ma7;
eq1(Nf7k) = cor*ma8;

g0(12,:) = eq0;
g1(12,:) = eq1;
Psi(12,:) = eq0ex;
%--------------------------------------------
%(15)	Capital Tax Revenue
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(NTk) = 1;
eq0(Ntauk) = -1;
eq0(Ny) = -1;
g0(13,:) = eq0;
g1(13,:) = eq1;
Psi(13,:) = eq0ex;
%--------------------------------------------
%(16)	Labor Tax Revenue
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(NTl) = 1;
eq0(Ntaul) = -1;
eq0(Ny) = -1;
g0(14,:) = eq0;
g1(14,:) = eq1;
Psi(14,:) = eq0ex;
%--------------------------------------------
%(17)	Income Tax Revenue
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nrev) = rev;
eq0(NTk) = -tk;
eq0(NTl) = -tl;
g0(15,:) = eq0;
g1(15,:) = eq1;
Psi(15,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (18)
%    f1k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf1k) = 1;
eq1(Nutk) = 1;
g0(16,:) = eq0;
g1(16,:) = eq1;
Psi(16,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (19)
%    f2k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf2k) = 1;
eq1(Nf1k) = 1;
g0(17,:) = eq0;
g1(17,:) = eq1;
Psi(17,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (20)
%    f3k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf3k) = 1;
eq1(Nf2k) = 1;
g0(18,:) = eq0;
g1(18,:) = eq1;
Psi(18,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (21)
%    f4k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf4k) = 1;
eq1(Nf3k) = 1;
g0(19,:) = eq0;
g1(19,:) = eq1;
Psi(19,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (22)
%    f5k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf5k) = 1;
eq1(Nf4k) = 1;
g0(20,:) = eq0;
g1(20,:) = eq1;
Psi(20,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (23)
%    f6k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf6k) = 1;
eq1(Nf5k) = 1;
g0(21,:) = eq0;
g1(21,:) = eq1;
Psi(21,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (24)
%    f7k
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf7k) = 1;
eq1(Nf6k) = 1;
g0(22,:) = eq0;
g1(22,:) = eq1;
Psi(22,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (25)
%    f1l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf1l) = 1;
eq1(Nutl) = 1;
g0(23,:) = eq0;
g1(23,:) = eq1;
Psi(23,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (26)
%    f2l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf2l) = 1;
eq1(Nf1l) = 1;
g0(24,:) = eq0;
g1(24,:) = eq1;
Psi(24,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (27)
%    f3l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf3l) = 1;
eq1(Nf2l) = 1;
g0(25,:) = eq0;
g1(25,:) = eq1;
Psi(25,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (28)
%    f4l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf4l) = 1;
eq1(Nf3l) = 1;
g0(26,:) = eq0;
g1(26,:) = eq1;
Psi(26,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (29)
%    f5l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf5l) = 1;
eq1(Nf4l) = 1;
g0(27,:) = eq0;
g1(27,:) = eq1;
Psi(27,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (30)
%    f6l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf6l) = 1;
eq1(Nf5l) = 1;
g0(28,:) = eq0;
g1(28,:) = eq1;
Psi(28,:) = eq0ex;
%--------------------------------------------------------------------------------
%   (31)
%    f7l
%--------------------------------------------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nf7l) = 1;
eq1(Nf6l) = 1;
g0(29,:) = eq0;
g1(29,:) = eq1;
Psi(29,:) = eq0ex;
%--------------------------------------------
%(32)	a Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nua) = 1;
eq1(Nua) = rhoa;
eq0ex(Nua) = siga;
g0(30,:) = eq0;
g1(30,:) = eq1;
Psi(30,:) = eq0ex;
%--------------------------------------------
%(33)	g Spending Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nug) = 1;
eq0ex(Nug) = sigg;
g0(31,:) = eq0;
g1(31,:) = eq1;
Psi(31,:) = eq0ex;
%--------------------------------------------
%(34)	tk Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nutk) = 1;
eq0ex(Nutk) = sigtk;
g0(32,:) = eq0;
g1(32,:) = eq1;
Psi(32,:) = eq0ex;
%--------------------------------------------
%(35)	tl Shock
%--------------------------------------------
eq0 = zeros(1,nvar);
eq1 = eq0;
eq0ex = zeros(1,nvar);
eq0(Nutl) = 1;
eq0ex(Nutl) = sigtl;
g0(33,:) = eq0;
g1(33,:) = eq1;
Psi(33,:) = eq0ex;
% %--------------------------------------------
% %(36)	Z Shock
% %--------------------------------------------
% eq0 = zeros(1,nvar);
% eq1 = eq0;
% eq0ex = zeros(1,nvar);
% eq0(Nuz) = 1;
% eq0ex(Nuz) = sigz;
% g0(34,:) = eq0;
% g1(34,:) = eq1;
% Psi(34,:) = eq0ex;